package constants;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Retrieving the constants from the Resource Bundle 
 */
public class Constant {
	private static final String BUNDLE_NAME = "constants.messages";

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

	private Constant() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}