package similarity;

import index.Term;
import index.Thesaurus;

import java.util.Iterator;
import java.util.List;

/**
 * LTC_LTC weighting scheme on VSM 
 * @see similarity.VSM
 */
public class LTC_LTC extends VSM {

	public LTC_LTC(Thesaurus thesauri) {
		super(thesauri);
	}

	protected double firstValue(Term term) {
		double df = thesauri.getNumberOfDocumentsContainingGram(term.getId());
		double tf = 1 + Math.log(term.getFrequency());
		
		double idf = Math.log(N / df);
		
		return tf * idf;
	}
	
	protected double secondValue(Term term) {
		return firstValue(term);
	}

	protected double firstNorm(List d1) {
		double sigmapow = 0;
		
		for (Iterator it = d1.iterator(); it.hasNext();) {
			Term term = (Term) it.next();
			
			sigmapow += Math.pow( firstValue(term), 2);
		}
		
		return Math.sqrt(sigmapow);
	}

	protected double secondNorm(List d2) {
		return firstNorm(d2);
	}

}
