package similarity;

import java.util.List;

import window.FileTooShort;

import constants.Constant;

import index.DirectoryNotFound;
import index.FileID;
import index.Thesaurus;

/**
 * Compute the similarity for all pair of documents based on VSM similarity 
 */
public class VSMSimilarity {

	public static void main(String[] args) {
		try {
			Thesaurus thesauri = new Thesaurus(Constant.getString("Clustering.HomeDirecory"));

			FileID[] fileIDs = thesauri.getFileIDs();
			VSM model = new LTC_LTC(thesauri);
			
			for (int i = 0; i < fileIDs.length; i++) {
				String primaryFileName = fileIDs[i].getFileName();
				List d1 = thesauri.getDocumentTerms(primaryFileName);
				System.out.println(primaryFileName + " ==> " + d1.size());
				
				for (int j = 0; j < fileIDs.length; j++) {
					String secondaryFileName = fileIDs[j].getFileName();
					List d2 = thesauri.getDocumentTerms(secondaryFileName); 
					
					double similarity = model.similarity(d1, d2);
					System.out.println("\t" + secondaryFileName + " , " + similarity);
				}
			}
		} catch (DirectoryNotFound e) {
			System.out.println("Directory must exist!!");
			System.out.println();
			e.printStackTrace(System.err);
			System.exit(1);
		} catch (FileTooShort e) {
			System.out.println("One of the files is too short!!");
			System.out.println();
			e.printStackTrace(System.err);
			System.exit(1);
		}
	}
}
